
from unittest.mock import MagicMock
from .settings import WekanSettings
from app.sink import BaseGroup, BaseUser, Sink
from .api import WekanApi
from .models import User


class WekanSink(Sink):

    def __init__(self):
        self._settings = WekanSettings()
        self._api = WekanApi(self._settings)

    @property
    def api(self):
        return self._api

    @api.setter
    def api(self, api):
        self._api = api

    def create_user(self, user: BaseUser):
         # TODO if not self.wekan.get_user(user.name):
        return self._api.create_user(username=user.username, email=user.email, password="")

    def create_group(self, group: BaseGroup):
        print("Create Wekan Group: ", group)
        pass

